/**************************************************************************************************
 *
 *	special.c
 *
 *	part of the layout program.
 *
 *
 *	Written by Gerard Leurs, NIKHEF-H, Amsterdam.
 *	July 1991.
 *	email: a89@nikhef.nl
 *
 *************************************************************************************************/

# include "layout.h"

	/* check empty sector for an empty corner. replace nodes in this corner */

static void empty_corner(sectornr, x_of_box, y_of_box)
int sectornr;
int x_of_box,y_of_box;
{
	struct hostentity * dummyhost1;

	dummyhost1 = host;

	while (dummyhost1 != NULL)
	{
		if ((sectornr == 1) || (sectornr == 3))
		{
			if (dummyhost1->x_coord < boundary)
				dummyhost1->x_coord = boundary;
			if (dummyhost1->x_coord <= (boundary + x_of_box) )
			{
				if (dummyhost1->y_coord >= (WINDOWheight - boundary - y_of_box - 10) )
					dummyhost1->y_coord = dummyhost1->y_coord - y_of_box - 10;
				else if (dummyhost1->y_coord <= (boundary + y_of_box + 10) )
					dummyhost1->y_coord = dummyhost1->y_coord + y_of_box + 10;
			}
		}
		if ((sectornr == 2) || (sectornr == 4))
		{
			if ((dummyhost1->x_coord + dummyhost1->width) > (WINDOWwidth - boundary))
				dummyhost1->x_coord = WINDOWwidth - boundary - dummyhost1->width;
			if ((dummyhost1->x_coord + dummyhost1->width) >= (WINDOWwidth - boundary - x_of_box) )
			{
				if (dummyhost1->y_coord >= (WINDOWheight - boundary - y_of_box - 10) )
					dummyhost1->y_coord = dummyhost1->y_coord - y_of_box - 10;
				else if (dummyhost1->y_coord <= (boundary + y_of_box + 10) )
					dummyhost1->y_coord = dummyhost1->y_coord + y_of_box + 10;
			}
		}

		dummyhost1 = dummyhost1->next;
	}
}


	/* put the nodes with more links, but only to one-link nodes, on the window */
	/* and add the one_link_nodes connected to this more_links_node */

extern void place_more_linked_nodes(sizecheck)
int sizecheck;
{
	struct hostentity * dummyhost1;			/* node to determine the number of links for */
	struct hostentity * dummyhost2;			/* one_link_node connected to special more_link_node */
	struct hostentity * newhost;
	int sector_tl, sector_tr, sector_bl, sector_br;		/* number of nodes in a kwadrant */
	int empty_sector;				/* the kwadrant to put the extra nodes in */
	int nodes;					/* number of more_links_nodes */
	int nodecount;					/* number of linked one_link_nodes to a more_links_node */
	int x_offset, y_offset;				/* starting x_value and y_value */
	int Right;					/* place next node to the right or not */
	int Up;						/* place next node above or not */
	int Found;

	/* determine in which sector the nodes are : bottomleft, bottomright, topleft or topright */

	sector_tl = sector_tr = sector_bl = sector_br = 0;

	dummyhost1 = host;

	while (dummyhost1 != NULL)
	{
		if ( (dummyhost1->x_coord + dummyhost1->width / 2) <= (WINDOWwidth / 2) )
		{
			if ( (dummyhost1->y_coord + dummyhost1->height / 2) > (WINDOWheight / 2) )
				sector_tl ++;
			else
				sector_bl ++;
		}
		else
		{
			if ( (dummyhost1->y_coord + dummyhost1->height / 2) > (WINDOWheight / 2) )
				sector_tr ++;
			else
				sector_br ++;
		}

		dummyhost1 = dummyhost1->next;
	}

	/* get the sector with lowest number of nodes */

	if (sector_tl <= sector_tr)
	{
		if (sector_bl <= sector_br)
		{
			if (sector_tl <= sector_bl)
				empty_sector = 1;
			else
				empty_sector = 3;
		}
		else
		{
			if (sector_tl <= sector_br)
				empty_sector = 1;
			else
				empty_sector = 4;
		}
	}
	else
	{
		if (sector_bl <= sector_br)
		{
			if (sector_tr <= sector_bl)
				empty_sector = 2;
			else
				empty_sector = 3;
		}
		else
		{
			if (sector_tr <= sector_br)
				empty_sector = 2;
			else
				empty_sector = 4;
		}
	}

	if (empty_sector == 1)
	{
		x_offset = boundary;	y_offset = WINDOWheight - boundary - DEFAULTheight;
		Right = TRUE;	Up = FALSE;
	}
	else if (empty_sector == 2)
	{
		x_offset = WINDOWwidth - boundary;	y_offset = WINDOWheight - boundary - DEFAULTheight;
		Right = FALSE;	Up = FALSE;
	}
	else if (empty_sector == 3)
	{
		x_offset = boundary;	y_offset = boundary;
		Right = TRUE;	Up = TRUE;
	}
	else
	{
		x_offset = WINDOWwidth - boundary;	y_offset = boundary;
		Right = FALSE;	Up = TRUE;
	}

	nodes = 0;
	dummyhost1 = host_more_to_one;
	while (dummyhost1 != NULL)
	{
		nodes ++;
		dummyhost1 = dummyhost1->next;
	}
	if (nodes != 0)
	{
		int y_value;
		if (nodes <= 3)
			y_value =  5 * (DEFAULTheight + 10);
		else if ( (nodes > 3) && (nodes <= 6) )
			y_value = 10 * (DEFAULTheight + 10);
		else if (nodes > 6)
			y_value = 15 * (DEFAULTheight + 10);
		empty_corner(empty_sector, ((nodes % 3) + 1) * ((WINDOWwidth / 5) + 10), y_value);
	}

	nodes = 0;
	newhost = host;
	dummyhost1 = host_more_to_one;

	while (dummyhost1 != NULL)
	{
		if (Right)
		{
			dummyhost1->x_coord = x_offset;
			x_offset += dummyhost1->width + 25;
		}
		else
		{
			dummyhost1->x_coord = x_offset - dummyhost1->width - 5;
			x_offset -= dummyhost1->width + 25;
		}
		dummyhost1->y_coord = y_offset;

		if (Debug)
			fprintf(stderr,"place_more_linked_nodes: %s %d %d %d %d\n",dummyhost1->hostname,dummyhost1->x_coord,
					dummyhost1->y_coord,dummyhost1->width,dummyhost1->height);

		newhost = addnodestructure(newhost, dummyhost1->id, dummyhost1->hostname,
					   dummyhost1->x_coord, dummyhost1->y_coord,
					   dummyhost1->width, dummyhost1->height,
					   dummyhost1->link, TRUE);

		nodes ++;
		if (nodes % 3 == 0)
		{
			if (Up)
				y_offset += ((5 * DEFAULTheight) + 10);
			else
				y_offset -= ((5 * DEFAULTheight) + 10);
			
		}

		/* place one_link_node close to this special more_links_node */

		nodecount = 1;
		dummyhost2 = host_one_link;

		while (dummyhost2 != NULL)
		{
			if (linked_or_not(dummyhost1->id, dummyhost2->id))
			{
				dummyhost2->x_coord = dummyhost1->x_coord;
				if (Up)
					dummyhost2->y_coord = dummyhost1->y_coord + dummyhost1->height
							    + (nodecount * (dummyhost2->height + 10));
				else
					dummyhost2->y_coord = dummyhost1->y_coord - dummyhost1->height
							    - (nodecount * (dummyhost2->height + 10));

				if (Debug)
					fprintf(stderr,"%s linked and placed on: %d %d %d %d %d\n",dummyhost2->hostname,
						dummyhost2->x_coord, dummyhost2->y_coord, dummyhost2->width,
						dummyhost2->height);

			/* place these also in the temp. structure (with more_linked_nodes) */

				newhost = addnodestructure(newhost, dummyhost2->id,dummyhost2->hostname,
							   dummyhost2->x_coord, dummyhost2->y_coord,
							   dummyhost2->width, dummyhost2->height,
							   dummyhost2->link, FALSE);
				nodecount ++;
			}

			dummyhost2 = dummyhost2->next;
		}

		dummyhost1 = dummyhost1->next;
	}

	/* save the more_linked_nodes and the special more_link_nodes with their connecting one_link_nodes.
	   replace the complete one_link_nodestructure by the structure without the one_link_nodes
	   connected to more_linked_nodes */

	host = newhost;
	newhost = NULL;

	dummyhost1 = host_one_link;

	while (dummyhost1 != NULL)
	{
		Found = FALSE;
		dummyhost2 = host;

		while (dummyhost2 != NULL)
		{
			if ((strcmp(dummyhost1->hostname, dummyhost2->hostname)) == 0)
				Found = TRUE;

			dummyhost2 = dummyhost2->next;
		}

		if (! Found)
			newhost = addnodestructure(newhost, dummyhost1->id, dummyhost1->hostname,
						   dummyhost1->x_coord, dummyhost1->y_coord,
						   dummyhost1->width, dummyhost1->height,
						   dummyhost1->link, TRUE);
		dummyhost1 = dummyhost1->next;
	}

	host_one_link = newhost;
}
