/************************************************************************************/
/************************************************************************************/
/*  $Header: //gaia/group.local/computer/monet/FileServer/RCS/main.c,v 1.3 1991/05/06 09:10:23 a38 Exp a38 $  */
/************************************************************************************/
/* $Log: main.c,v $
 * Revision 1.3  1991/05/06  09:10:23  a38
 * *** empty log message ***
 * */
/************************************************************************************/

#include "request.h"
#include "general/Log.h"
#include "io/io.h"

#include <sys/file.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <setjmp.h>

/********************************************************************************/
/*  Globals  */
/********************************************************************************/

int yylineno;  /* !!!!  Hack */
static jmp_buf env;
Log PingerLog;

/****************************************************************************/
/*  Signal handlers   */
/****************************************************************************/

static void sig_alarm ()
{
	sys_error   ("Caught SIGALRM");
	user_inform ("Caught SIGALRM");
	exit (2);
}

static void sig_virtualalarm ()
{
	sys_error   ("Caught SIGVTALRM");
	user_inform ("Caught SIGVTALRM");
	exit (6);
}

static void sig_hangup ()
{
	sys_error   ("Caught SIGHUP");
	user_inform ("Caught SIGHUP");
	exit (3);
}

static void sig_quit ()
{
	sys_error   ("Caught SIGQUIT");
	user_inform ("Caught SIGQUIT");
	exit (4);
}


static void terminate ()
{
	sys_error   ("Caught INT");
	finish_request ();
	free_log (PingerLog);
	Monet_finish ();
	exit(0);
}

static void resume ()
{
/*	write_log ("SIGHUP", "Restarting"); */
	longjmp( env, 1);
}

/*****************************************************************************
 * detach all associtaed terminals and chdir to the root
 *****************************************************************************/

#define BSD

/* #include <stdio.h> */
/* #include <WIDE/widelib.h> */
/* #include <signal.h> */

detach()
{
	int fd,nfile;

#ifdef SIGTTOU
	signal(SIGTTOU,SIG_IGN);
#endif SIGTTOU
#ifdef SIGTTIN
	signal(SIGTTIN,SIG_IGN);
#endif SIGTTIN
#ifdef SIGTSTP
	signal(SIGTSTP,SIG_IGN);
#endif SIGTSTP
	if (fork() != 0) {
		exit(0);
	}
#ifdef BSD
	setpgrp(0,getpid());
	if ((fd = open("/dev/tty",O_RDWR)) >= 0) {
		ioctl(fd,TIOCNOTTY,0);
		close(fd);
	}
#else /* SYSV */
	setpgrp();
	if (fork() != 0) {
		exit(0);
	}
#endif
	nfile = getdtablesize();
	for (fd = 0 ; fd < nfile ; fd++) {
		close(fd);
	}
	open("/", O_RDONLY);
	dup2(0, 1);
	dup2(0, 2);
	chdir("/");
	umask(0);
	return;
} /* detach() */

/****************************************************************************/
/*   Main */
/****************************************************************************/

main (argc, argv)
	int             argc;
	char           **argv;
{
	Monet_init ("monetmapd", NULL, argc, argv);
	PingerLog = create_log (Config_program_name, 0, True);
	init_request ();

	(void) start_server ();
	(void) init_connections (Config_mapserver_port);

	/*  Catch miscelaneous signals for no very good reason  */
	signal (SIGVTALRM, sig_virtualalarm);
	signal (SIGALRM, sig_alarm);
	signal (SIGHUP, sig_hangup);
	signal (SIGQUIT, sig_quit);

	/*  Restart if SIGHUP received, die if Kill or interupt sent  */
	setjmp (env);               /* restart point */
	signal (SIGHUP, resume);    /* when receive SIGHUP, clear everything and */
	signal (SIGINT, terminate); /* when receive SIGINT, the daemon terminates */
	signal (SIGKILL, terminate);


#ifdef ABCDEF
	if ( g_mode == DAEMON_MODE ) {
		EPRINTF( fp_msg, "%s: being a daemon process. forking...\n", Myname);
		detach(); /* Dissociate server from controlling terminal */
		/* All file descripters are closed. */
	}
#endif

	while (True) {
		long timenow = time (0);
		/* Waits for requests to come in but does not return in less than */
		/* Config_monetd_delay seconds. */
		wait_for_messages (timenow, Config_monetd_delay, NULL, NULL);
	}
	close_server ();
	finish_connections ();

	/* NOTREACHED */
}

/************************************************************************************/
/************************************************************************************/
/*  $Header: //gaia/group.local/computer/monet/FileServer/RCS/main.c,v 1.3 1991/05/06 09:10:23 a38 Exp a38 $  */
/************************************************************************************/
/************************************************************************************/


