/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

#include "map/Drawing.h"
#include "map/Script.h"
#include "general/Help.h"
#include "general/Channel.h"
#include "map/Layout.h"
#include "io/io.h"
#include <signal.h>
#include <sys/types.h>
#include <errno.h>
#include <sys/ioctl.h>

FILE * source;

/***************************************************************************/
/*  Finish off */
/***************************************************************************/

static void finish ()
{
	if (source != stdin)
		fclose (source);
	close_server ();
	ClassDrawing_finish ();
	Monet_finish ();
	exit (0);
}

/*****************************************************************************/
/*  Call interpreter  */
/*****************************************************************************/

static void script_callback (fd, data)
	int fd;
	caddr_t data;
{
	Script_execute_fd (fd, (Boolean) data);
}

static void change (map)
	Map map;
{
}

/*****************************************************************************/
/*  The top */
/*****************************************************************************/

main(argc, argv)
	int             argc;
	char           **argv;
{
	int n = 1, i, fd;
	long converter;
	caddr_t converter_caddr_t;
	Boolean Interactive;

	Monet_init ("monetsh", finish, argc, argv);
	ClassMap_init (change);

	start_server ();

	Script_execute (Config_startup_command);

	Interactive = True;
	source = stdin;
	fd = fileno (source);

	if (Interactive) {
		printf ("%s> ", Config_program_name);
		fflush (stdout);
	}
	ioctl(fd, FIONBIO, &n);
	/* -- Casting 'Interactive' into a pointer should be okay */
	/* -- because it is never actually used as one. However, gould */
	/* -- doesn't like it, so have to convert it into long first. */
	converter = (long) Interactive;
	converter_caddr_t = (caddr_t) converter;
	(void) create_input_fid (fd, fid_read, script_callback, converter_caddr_t);
	while (True) {
		long timenow = time (0);
		/* Waits for requests to come in but does not return in less than */
		/* Config_monetd_delay seconds. */
		wait_for_messages (timenow, Config_monetd_delay, NULL, NULL);
	}
	/* NOTREACHED */
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/

