.TH XMONET 1N "Release 0.2-Beta"
.\" $Header$
.\"
.\" $Log$
.\" 
.SH NAME
.B xmonet
\- X based network mapping and monitoring station
.SH SYNOPSIS
.B xmonet
<monet options ...>
.SH DESCRIPTION
The
.I xmonet
program provides a window-oriented user interface to the \fIMonet\fR network
mapping and monitoring system.  Maps can be drawn and monitored interactively
and used to build up a database of information about network entities.  Maps
can be loaded from local files or from a remote server, \fImonetservd (8)\fR.
Monitoring information is collected by a set of distributed monitoring agents.

.SH  MONITORING
Monitoring is done using the \fImonetd(8N)\fR agent.  At start up you can connect
to your local agent and all the systems on the map will be automatically monitored.

.SH XMONET AND THE WIDGET CREATION LIBRARY
\fIXmonet\fR uses the Widget Creation Library to produce its windows, scrollbars,
etc.  This allows the widget heirarchy to be created from the X application defaults file.
For more information, see the WCL documentation.
.PP
Currently there is only one resource file defined for \fIxmonet\fR which uses the
Athena Widget Set.  Another one could be written which uses the Motif widget set
without makes changes to the code.  This flexibilty and the ease of making changes
were the reasons for incoperating it.
.PP
\fImonet\fR will not work unless you have entered \fIXMonet.ad\fR into the resource
database.  There are various ways of doing this the simplest being \fBxrdb XMonet.ad\fR.
.PP
The best documentation to the user interface is \fIXMonet.ad\fR itself and you should
look at that if you want to customize the front end.

.SH CONFIRMATION DIALOG BOXES
Whenever you press a button that may cause you to lose some work or is
otherwise dangerous, a popup dialog box will appear asking you to confirm the
action.  This window will contain an ``Abort'' or ``No'' button and a
``Confirm'' or ``Yes''
button.  Pressing the ``No'' button cancels the operation, and pressing
the ``Yes'' will proceed with the operation. 

.SH MAP EDITING COMMANDS

Virtually all the commands are available from menus, many of which have
keystroke equivalents which are shown in the menus.  Operations
available while on a map are listed below, these are for popping up menus
and using rubberbands.  The maps are also available from the top row
of buttons.
.sp
.TP
.B	Ctrl<Button1>
Commands Menu
.TP
.B	Ctrl<Button2>
Map Menu
.TP
.B	Ctrl<Button3>
Map Options Box
.TP
.B	Shift<Button1>
Load maps menu
.TP
.B	Shift<Button2>
User Defined Actions Menu
.TP
.B	Shift<Button3>
Layout Box
.TP
.B	<Button1>
Move
.TP
.B	<Button2>
Select
.PP
.B	<Button3>
Resize


.SH BASIC SCREEN LAYOUT
\fIxmonet\fR starts out with a single window, divided into a number of areas:

.TP 4
.B Top Row
\-
A line of buttons with pull-down command menus.
.PP
.TP 4
.B Top Right
\-
A box showing the name of the current map.
.PP
.TP 4
.B Left
\-
A text box where messages are displayed.
.PP
.TP 4
.B Left
\-
A group of buttons with help boxes attched.
.PP
.TP 4
.B Left
\-
A text box for entering data.
.PP
.TP 4
.B Right Side
\-
A large empty map.
.PP
.TP 4
.B Bottom Left
\-
A map showing all the defined classes.

.SH POPUPS
.TP 4
.B Command Menu
\-
basic editing commands.
.PP
.TP 4
.B Layout Box
\-
various commands for untangling and laying out maps.
.PP
.TP 4
.B Load Map
\-
for loading saving and popping up maps.
.PP
.TP 4
.B Remote Maps
\-
for accessing the remote map server.
.PP
.TP 4
.B Options
\-
for setting various map options.
.PP
.TP 4
.B Action
\-
for executing shell and monet shell commands.
External commands and features like traceroute are
hooked in here.
.PP
.TP 4
.B Map Menu
commands for a whole map.


.SH CALLBACKS AND ACTIONS

Most of the functionality is provided by calling the monetsh command interpreter
from a callback or action.  These are also available as actions with the CB suffix
replaced by ACT.
.PP
The following are for executing monetsh commands, before execution
the character '&' is replaced by the name of the currently selected entity.
The character '+' preceding the name of a text of dialog widget is replaced
by the value of the widget.
.TP 4
.B MonetShellCommandCB
Calls a bourne shell (sh) command and pipes the output to a window.
.TP 4
.B MonetScriptCommandCB
executes a monet shell command.  If the first character is a
'+' then it is executed directly else the argument is taken as the name
of a text or dialog widget which has the instruction.
.TP 4
.B MonetShellInterpreterCB
similar to above but expects the shell command to return
a sequence of monetsh commands which are then executed.  This is used for the implementation
of traceroute.

.SH DIAGNOSTICS
These are pretty awful, many messages are more for debugging than
information.  There should be better structuring so that messages
are shown in better places on the map.
.PP
System errors a reported directly the stderr, not to a window.
These do not always mean something catastrophic happened, rather
a bug in the program has been caught.

.SH FILES
~/.monet - local configuration
.br
/etc/monet - config directory
.br
/tmp - temporary files
.SH "SEE ALSO"
monet(1N), monetd(8N), monetrc(5N), maps(5N), X(1)
.SH BUGS
- No undo
.br
- Should drop into command mode if not connected to x-terminal
.br
- Should be able to choose, motif, Xaw, and colours.
.br
- Cannot draw lines between a systems in different maps.
.br
- When executing an external command the output is only
displayed when it has completed not as it becomes available.
.br
- Error messages should be written some place more obvious.
.br
- Calling shell programs while in X windows does not seem to work
correctly when using SYS5.
.br
- The action stuff will not work most of the time.
.br
- The biggest problem is that no one has really tried to sit down
and use the stuff for thoroughly.  The functionality is there or
could be hooked on quite easily in a lot of cases, but this needs
some serious time spent on it.
.SH AUTHOR
James Barr, NIKHEF-H, Amsterdam
