#ifndef _REDIRECT_H_
#define _REDIRECT_H_

typedef struct redirect_rule * RedirectRule;

#ifdef MONET_PROTOTYPES

extern void		init_redirect		(void);
extern void		finish_redirect		(void);
extern RedirectRule	create_redirect		(String, int, String);
extern void		free_redirect		(RedirectRule);
extern RedirectRule	try_redirect		(Entity);
extern Boolean		isRedirected		(Entity);
extern void		reconnect_redirects	(void);
extern void		disable_redirects	(void);
extern void		enable_redirects	(void);
extern Boolean		stop_redirect		(Entity);
extern void		clear_redirects		(void);
extern void		list_redirects		(void);
extern Boolean		redirect_connected	(RedirectRule);
extern void		Redirect_get_info	(RedirectRule rule, String *host, int *port, String *pattern);
extern String		parse_monitor_instruction (String);
extern void		Redirect_say_hello	(RedirectRule);

#else

extern void		init_redirect		();
extern void		finish_redirect		();
extern RedirectRule	create_redirect		();
extern void		free_redirect		();
extern RedirectRule	try_redirect		();
extern Boolean		isRedirected		();
extern void		reconnect_redirects	();
extern void		disable_redirects	();
extern void		enable_redirects	();
extern Boolean		stop_redirect		();
extern void		clear_redirects		();
extern void		list_redirects		();
extern Boolean		redirect_connected	();
extern void		Redirect_get_info	();
extern String parse_monitor_instruction ();
extern void		Redirect_say_hello	();

#endif

#endif /*  _REDIRECT_H_ */
