/********************************************************************************/
/********************************************************************************/
/*  $Header$  */
/********************************************************************************/
/********************************************************************************/

#include "db/Entity.h"

/********************************************************************************/

/********************************************************************************/

extern void init_components ()
{
}

extern void finish_components ()
{
}

extern void load_component (super, sub)
	char * super, * sub;
{
	Entity o_super, o_sub;

	if ((o_super = string2entity (super)) == NULL) {
		user_error ("[%s] does not exist", super);
		return;
	}
	if ((o_sub   = string2entity (sub)) == NULL) {
   		user_error ("[%s] does not exist", sub);
		return;
	}
	if (isSubcomponent (o_super, o_sub)) {
		user_error ("Already subcomponent");
		return;
	}
	make_subcomponent (o_super, o_sub);
}


extern void make_subcomponent (super, sub)
	Entity super, sub;
{
	if (super == sub)
		return;
	if ( ! isMember_entityList (super->subcomponents, sub))
		insert_entityList (super->subcomponents, sub);
	if ( ! isMember_entityList (sub->supercomponents, super))
		insert_entityList (sub->supercomponents, super);
	MASK(super) |= StatusComponentMask;
}

extern void unmake_subcomponent (super, sub)
	Entity super, sub;
{
	extract_entityList (super->subcomponents, sub);
	extract_entityList (sub->supercomponents, super);
	MASK(super) |= StatusComponentMask;
}

/*  Removes all of an objects supercomponents and sucomponents */
extern void free_components (sys)
	Entity sys;
{
	Entity s;
	FOR_ENTITYLIST (s, sys->subcomponents)
		extract_entityList (s->supercomponents, sys);
	FOR_ENTITYLIST (s, sys->supercomponents)
		extract_entityList (s->subcomponents, sys);
	reset_entityList (sys->subcomponents);
	reset_entityList (sys->supercomponents);
}


extern Boolean isSubcomponent (super, sub)
	Entity super, sub;
{
	return isMember_entityList (super->subcomponents, sub);
}

extern Boolean isSupercomponent (super, sub)
	Entity super, sub;
{
	if (super == sub)
		return False;
	/* !! Should we allow cycles? !!! */
	return isMember_entityList (sub->supercomponents, super);
}

/********************************************************************************/
/********************************************************************************/
/*  $Header$  */
/********************************************************************************/
/********************************************************************************/

