/***************************************************************/
/***************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/db/RCS/trigger.c,v 1.1 1991/06/04 07:10:28 a38 Exp a38 $  */
/***************************************************************/
/***************************************************************/

#include "Entity.h"

extern StatusTrigger ChangeTrigger;
static struct status status_buffer;
static VStatus before = &status_buffer;

#define TRIG1 	if (status == NULL) return False; \
		/* status->mask = StatusNoneMask; */ \
		bcopy (status, &status_buffer, sizeof(status_buffer));
#define TRIG2	if (ChangeTrigger) { \
			ChangeTrigger (before, status, status->change_data); \
		} \
		return True;

/***************************************************************/
/*  Utilities for parsing messages  */
/***************************************************************/

static Boolean get_cardinal (value, place)
	Cardinal *value;
	char  **place;
{
	int cc;
	char *s = *place;

	if (!isdigit(*s)) {
		sys_error ("Bad request [%s]", s);
		return False;
	}

	for (*value = 0; isdigit(*s); s++)
		*value = (*value) * 10 + (Cardinal) (*s - '0');
	*place = s;
	return True;
}

#define ignore_rest_of_message(i) for (; *i != MonitorEndCode && *i != NULL; i++);

static String get_string (place)
	char ** place;
{
	char * name, *i = *place;

	if (*i != '(') {
		sys_error ("Missing ( from response [%s]", place);
		return False;
	}
	i++;
	name = i;
	for (; *i != NULL && *i != ')'; i++) {}
	*place = i+1;
	if (i > name)
		return NULL;
	*i = NULL;
	return name;
}

static char get_char (place)
	char ** place;
{
	char value = **place;
	(*place) ++;
	return value;
}

/***************************************************************/
/*  Set various attributes and call a trigger procedure        */
/***************************************************************/

extern Boolean set_reachability (status, reachable)
	ReachStatus reachable;
	VStatus status;
{
	TRIG1;
	SetReachStatusMask(status, reachable);
	TRIG2;
}

extern Boolean set_capacity (status, capacity)
	Capacity capacity;
	VStatus status;
{
	TRIG1;
	SetCapacityStatusMask(status, capacity);
	TRIG2;
}

extern Boolean set_num_connections (status, connections)
	Cardinal connections;
	VStatus status;
{
	TRIG1;
	SetConnectionsStatusMask(status, connections);
	TRIG2;
}

extern Boolean set_future (status, future)
	FutureStatus future;
	VStatus status;
{
	TRIG1;
	SetFutureStatusMask(status, future);
	TRIG2;
}

extern Boolean set_behaviour (status, behaviour)
	Behaviour behaviour;
	VStatus status;
{
	TRIG1;
	SetBehaviourStatusMask(status, behaviour);
	TRIG2;
}

extern Boolean set_load_out (status, traffic)
	Load traffic;
	VStatus status;
{
	TRIG1;
	SetLoadOutStatusMask(status, traffic);
	TRIG2;
}

extern Boolean set_load_in (status, traffic)
	Load traffic;
	VStatus status;
{
	TRIG1;
	SetLoadInStatusMask(status, traffic);
	TRIG2;
}

extern Boolean set_contact (status, contact)
	VStatus status;
	String contact;
{
	TRIG1;
	SetContactStatusMask(status, contact);
	TRIG2;
}

extern Boolean set_title (status, title)
	VStatus status;
	String title;
{
	TRIG1;
	SetTitleStatusMask(status, title);
	TRIG2;
}

extern Boolean set_neighbour (status)
	VStatus status;
{
	TRIG1;
	status -> mask |= StatusNeighbourMask;
	TRIG2;
}

extern Boolean set_ping (status, title)
	VStatus status;
	String title;
{
	TRIG1;
	if (status->ping)
		MonetFree(status->ping);
	status->ping = MonetNewString(title);
	status -> mask |= StatusPingMask;
	TRIG2;
}

/***************************************************************/
/***************************************************************/
/*  $Header: //gaia/group.local/computer/monet/lib/db/RCS/trigger.c,v 1.1 1991/06/04 07:10:28 a38 Exp a38 $  */
/***************************************************************/
/***************************************************************/

