


#ifndef _KEYLIST_H_
#define _KEYLIST_H_

/**********************************************************/
/*  Maintain a keyed extendable list                      */
/*  To change the key., extract then reinsert             */
/**********************************************************/

typedef struct KeyList * KeyList;
#define NULL_KEYLIST  NULL

/**********************************************************/
/*  Prototype for searching scanning whole list           */
/**********************************************************/

#define FOR_KEYLIST(o, list) for (o=first_KeyList (list); o != NULL; o=next_KeyList (list))

#define SEARCH_KEYLIST(o, list, key) for (o=KeyList_search (list, key); o != NULL; o=KeyList_search_next (list))


/**********************************************************/
/*  Functions  */
/**********************************************************/

#ifdef MONET_PROTOTYPES

extern Boolean		extract_KeyList	(KeyList, caddr_t);
extern KeyList		create_KeyList	(void);
extern void		reset_KeyList	(KeyList);
extern void		free_KeyList	(KeyList);
extern void		insert_KeyList	(KeyList, caddr_t item, char ** key);
extern Boolean		isEmpty_KeyList	(KeyList);
extern caddr_t		getN_KeyList	(KeyList, Cardinal);
extern caddr_t		first_KeyList	(KeyList);
extern caddr_t		next_KeyList	(KeyList);
extern Cardinal		sizeOf_KeyList	(KeyList);
extern caddr_t		second_KeyList	(KeyList);
extern Boolean		isMember_KeyList(KeyList, caddr_t item);
extern KeyList		KeyList_search	(KeyList, char * key);
extern KeyList		KeyList_search_next (KeyList);

#else

extern Boolean		extract_KeyList	();
extern KeyList		create_KeyList	();
extern void		reset_KeyList	();
extern void		free_KeyList	();
extern void		insert_KeyList	();
extern Boolean		isEmpty_KeyList	();
extern caddr_t		getN_KeyList	();
extern caddr_t		first_KeyList	();
extern caddr_t		next_KeyList	();
extern Cardinal		sizeOf_KeyList	();
extern caddr_t		second_KeyList	();
extern Boolean		isMember_KeyList();
extern KeyList		KeyList_search	();
extern KeyList		KeyList_search_next ();

#endif


#endif
