
#ifndef MONET_LOG_H
#define MONET_LOG_H

typedef struct log   * Log;

#ifdef MONET_PROTOTYPES

extern void init_logs			(void);
extern void finish_logs			(void);
extern Log create_log			(char * name, int maxsize, int append);
extern void free_log			(Log);
extern void write_log			(Log, char *, char *, ...);
extern void write_comment_log		(Log, char *, ...);
extern void write_timestamped_log	(Log, char * type, char *, ...);
extern char * time_stamp		(void);
extern char * pretty_time_stamp		(void);
extern void flush_log			(Log);
extern char * clock2text		(long clock);

#else

extern void init_logs			();
extern void finish_logs			();
extern Log create_log			();
extern void free_log			();
extern void write_log			();
extern void write_comment_log		();
extern void write_timestamped_log	();
extern char * time_stamp		();
extern char * pretty_time_stamp		();
extern void flush_log			();
extern char * clock2text		();

#endif

#endif
