
/* $Header$ */

#ifndef _MONET_FILE_SERVER_H_
#define _MONET_FILE_SERVER_H_

typedef enum {	fs_doing = '{',
	fs_end = '}',
	fs_error = '!',
	fs_locked = 'l'
	}
	FileServerCode ;

typedef struct fileserverconnection * FileServerConnection;

typedef Boolean (* FileServerCallback) PR((FileServerConnection, FileServerCode, String));

#define DOING_TRANSFER "{"
#define END_TRANSFER   "}"
#define ERROR_TRANSFER "!"
#define LOCKED_TRANSFER "l"

#ifdef MONET_PROTOTYPES

extern void FileServer_init			(void);
extern void FileServer_finish			(void);
extern FileServerConnection FileServer_request	(String host, Cardinal port, FileServerCallback, String request);
extern Boolean FileServer_abort			(FileServerConnection);
extern String MapServer_name2filename		(String name);
extern String MapServer_filename2name		(String filename);
extern FILE * MapServer_fopen_save		(String name);
extern FILE * MapServer_fopen_load		(String filename);

#else

extern void FileServer_init			();
extern void FileServer_finish			();
extern FileServerConnection FileServer_request	();
extern Boolean FileServer_abort			();
extern String MapServer_name2filename		();
extern String MapServer_filename2name		();
extern FILE * MapServer_fopen_save		();
extern FILE * MapServer_fopen_load		();

#endif

#endif


/* $Header */
