/**********************************************************/
/**********************************************************/
/* $Header: //gaia/group.local/computer/monet/libsrc/FileServer/RCS/client.c,v 1.3 1991/05/08 11:55:40 a38 Exp a38 $  */
/**********************************************************/
/* $Log: client.c,v $
 * Revision 1.3  1991/05/08  11:55:40  a38
 * *** empty log message ***
 *
 * Revision 1.2  1991/05/06  08:22:35  a38
 * *** empty log message ***
 * */
/**********************************************************/

#include "general/General.h"
#include "general/Channel.h"
#include <netdb.h>
#include "general/MapServer.h"

struct fileserverconnection {
	FileServerCallback call;
	String host;
	int port;
	Channel channel;
	String result;
};

/***************************************************************************/
/*  When a channel disconnects we must set all the Redirects connected     */
/*  to it to NULL.  The redirects themselves are not destroyed, just       */
/*  disabled until a new channel can be created.                           */
/***************************************************************************/

static void disconnect (conn)
	FileServerConnection conn;
{
	Channel_free (conn->channel);
	conn->channel = NULL;
	MonetFree (conn->host);
	MonetFree (conn);
}

/***************************************************************************/
/*  Callback for handling incoming data */
/***************************************************************************/

static Boolean handle_response (conn, result)
	FileServerConnection conn;
	String result;
{
	FileServerCode code;

	if (conn == NULL)
		return False;

/*	user_inform ("Debug: Received [%s] from file server", result); */

	/* !!! Remove leadings spaces, a bit of a hack */
	while (*result == ' ' && *result != NULL)
		result ++;

	code = (FileServerCode) (result[0]);
	if (conn->call)
		conn->call (conn, *result, result+1);

	switch (code) {
	case fs_doing:
		break;
	default:
	case fs_end:
	case fs_error:
	case fs_locked:
		/* Drop the connection */
		return False;
	}
	return True;
}

/***************************************************************************/
/* Directory operations */
/***************************************************************************/

extern FileServerConnection FileServer_request	(host, port, call, request)
	String host;
	Cardinal port;
	FileServerCallback call;
	String request;
{
	FileServerConnection conn;

	conn = MonetNew (struct fileserverconnection);
	conn -> host = MonetNewString (host);
	conn -> port = port;
	conn -> call = call;
	conn -> channel = Channel_create_client (
		conn->port, conn->host, handle_response, disconnect, (caddr_t) conn);
	Channel_send (conn->channel, request);
	Channel_end_of_record (conn->channel);
	return conn;
}

extern Boolean FileServer_abort (conn)
	FileServerConnection conn;
{
	if (conn->channel == NULL)
		return False;

	disconnect (conn);
	return True;
}

/***************************************************************************/
/*  Init and finish  */
/***************************************************************************/

extern void FileServer_init			()
{
}

extern void FileServer_finish			()
{
}

/**********************************************************/
/**********************************************************/
/*  $Header: //gaia/group.local/computer/monet/libsrc/FileServer/RCS/client.c,v 1.3 1991/05/08 11:55:40 a38 Exp a38 $  */
/**********************************************************/
/**********************************************************/


