


#ifndef MONET_SCRIPT_H
#define MONET_SCRIPT_H


typedef struct script_macro * ScriptMacro;

#define MAXSCRIPTCOMMANDLEN 4096
#define MAXSCRIPTARG 10

#define SCRIPTCALLBACK(name) static String name (arg, pipe) \
	String * arg, pipe; \
{ String result = "";
#define RETURNSC return result;
#define ENDSC return result; }


#ifdef MONET_PROTOTYPES

typedef String (* ScriptCallback) ();
extern ScriptMacro ScriptMacro_create	( \
	String name, String value, ScriptCallback, String help, String details);
extern void	ScriptMacro_deeper	(void);
extern void	ScriptMacro_shallower	(void);
extern String	Script_execute		(String command);
extern Boolean	Script_execute_fd	(int fd, Boolean interactive);

extern void	Script_init		(MonetFinishRoutine);
extern void	Script_finish		(void);

#else

typedef String	(* ScriptCallback) ();
extern ScriptMacro ScriptMacro_create	();
extern void	ScriptMacro_deeper	();
extern void	ScriptMacro_shallower	();
extern String	Script_execute		();
extern Boolean	Script_execute_fd	();
extern void	Script_init		();
extern void	Script_finish		();

#endif





#endif
