/***************************************************************************/
/***************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/draw/RCS/Shape.h,v 1.1 1991/05/30 14:58:21 a38 Exp a38 $ */
/***************************************************************************/
/***************************************************************************/

#ifndef MONET_SHAPE_H
#define MONET_SHAPE_H

#include "general/Draw.h"

/***************************************************************************/
/*  The basic shape class  */
/***************************************************************************/

typedef struct shape  * Shape;
#define DEFAULT_SHAPE NULL

/***************************************************************************/
/*  How connectors (interfaces) are shown  */
/***************************************************************************/

typedef enum {
	connector_default = 0,
	connector_small = 1,
	connector_invisible = 2,
	}
	ConnectorState;

/***************************************************************************/
/*  Functions  */
/***************************************************************************/

#ifdef MONET_PROTOTYPES
extern Shape		String2Shape		(String);
extern String		Shape2String		(Shape);
extern void		Shape_prepare		(Shape, Boolean force_label,
							ConnectorState, Dimension, Dimension,
							Dimension *, Dimension *, String);
extern void		Shape_draw		(Shape, Boolean force_label,
							Shade, Shade, Boolean,
							Position, Position, Dimension, Dimension, Dimension, Dimension,
							String, String);
extern void		Shape_adjust		(Shape, Dimension *, Dimension *);
extern ConnectorState	String2ConnectorState	(String);
extern Boolean		Shape_resizable		(Shape);
extern Boolean		Shape_isConnector	(Shape);
extern void		ClassShape_list		(void);
extern void		ClassShape_init		(void);
extern void		ClassShape_finish	(void);

#else

extern Shape		String2Shape		();
extern String		Shape2String		();
extern void		Shape_prepare		();
extern void		Shape_draw		();
extern void		Shape_adjust		();
extern Boolean		Shape_resizable		();
extern Boolean		Shape_isConnector	();
extern ConnectorState	String2ConnectorState	();
extern void		ClassShape_list		();
extern void		ClassShape_init		();
extern void		ClassShape_finish	();

#endif

/***************************************************************************/
/***************************************************************************/

#endif /* MONET_SHAPE_H */
