/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/general/RCS/general.c,v 1.2 1991/07/10 12:50:54 a38 Exp a38 $ */
/*****************************************************************************/
/*  Hmm!  more could be done  */
/*  The host program most define a printer routine 'user_message'  */
/*****************************************************************************/

#include "General.h"
#include <netdb.h>
#include <varargs.h>
#include <ctype.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/dir.h>

/*****************************************************************************/
/*  Globals  */
/*****************************************************************************/

char * CurrentFunction = NULL;

/*****************************************************************************/
/*  Is a point outwith a rectangle  */
/*****************************************************************************/

extern Boolean outofBounds (x,y, xb,yb,wb,hb)
	Position x,y;
	Dimension xb,yb,hb,wb;
{
	if (x>=xb)
		if (y>=yb)
			if (x<=xb+wb)
				if (y<=yb+hb)
					return False;
	return True;
}

/*****************************************************************************/

/*****************************************************************************/

extern String MonetTidyString (src)
	String src;
{
	String val;
	val = tidy_name (src);
	if (! val || !(*val))
		return NULL;
	return val;
}

extern Boolean MonetIsWord (src)
	String src;
{
	String val;
	val = tidy_name (src);
	if (! val || !(*val))
		return False;
	return True;
}

/*****************************************************************************/
/*  Replace one all occurences of one string in another  */
/*  Allows an escape character */
/*****************************************************************************/

extern String MonetReplaceInString (source, search, replacement)
	String source, search, replacement;
{
	static char new[2048];
	int count;
	char * c;

	if (MonetStrlen (search) == 0)
		return source;
	if (MonetStrlen (search) > 1)
		sys_error ("MonetReplaceInString: len>1 not yet implemented !!!");

	for (count = 0, c = source; *c!=NULL && count < sizeof(new); ++c) {
		if (count + 1 == sizeof(new)) {
			user_inform ("Command too long, truncating");
			break;
		} else if (*c == search[0]) {
			if (replacement) {
				char * p;
				for (p = replacement; *p; p++, count++) {
					if (count + 1 == sizeof(new)) {
						user_inform ("Command too long, truncating");
						break;
					} else {
						new[count] = *p;
					}
				}
			} else {
				user_error ("No system selected");
				return NULL;
			}
		} else {
			if (*c == '\\')
				++c;
			/*** Copy the character in the template into the request string ***/
			new[count] = *c;
			++count;
		}
	}
	new[count] = NULL;

	return new;
}

/*****************************************************************************
	looks in 'place' for next non whitespace char and returns
	pointer to it.  'place' is set to next whitespace(or null)
	char after this.
*****************************************************************************/

extern String MonetNextWord (place)
	String *place;
{
	String word;
	for (word = *place; SPACEORTAB(*word) ; ++word);
	for (*place = word; **place && !SPACEORTAB(**place) ; ++(*place));

	return word;
}


/*****************************************************************************/
/*  Finds a file using wildcards in a given directory  */
/*****************************************************************************/

extern String Monet_findfile (dir, pattern)
	String dir, pattern;
{
	DIR * dirp;
	struct direct *dp;
	static char result [MAXPATHLEN+1];

	dir = MonetFilename (dir);
	dirp = opendir(dir);
	if (dirp) {
		Cardinal matched = 0;
		*result = '\0';
		for (dp = readdir(dirp); dp != NULL; dp = readdir(dirp))
			if (wildmat (dp->d_name, pattern)) {
				(void) strcpy (result, dp->d_name);
				++ matched;
			}
		closedir(dirp);
		if (matched > 1) {
			user_error ("Ambiguous filename [%s] %u matches", pattern, matched);
		} else if (matched == 0) {
			user_error ("Could not find file matching [%s] in directory [%s]", pattern, dir);			
		} else {
			return result;
		}
	} else {
		user_error ("Could not access directory [%s]", dir);
	}
	return NULL;
}

extern Boolean Monet_list_dir (dir, pattern)
	String dir;
	String pattern;
{
	DIR * dirp;
	struct direct *dp;

	dir = MonetFilename (dir);
	dirp = opendir(dir);
	if (dirp) {
		Cardinal matched = 0;
		start_report ("Listing directory [%s]", dir);
		for (dp = readdir(dirp); dp != NULL; dp = readdir(dirp))
			if (wildmat (dp->d_name, pattern)) {
				writeln_report ("  %s", dp->d_name);
				++ matched;
			}
		closedir(dirp);
		if (matched == 0)
			user_error ("Could not find files matching [%s] in directory [%s]", pattern, dir);
		else
			writeln_report ("Listed %u files matching [%s] in directory [%s]", matched, pattern, dir);
		end_report ();
	} else {
		user_error ("Could not access directory [%s]", dir);
		return False;
	}
	return True;
}

/*****************************************************************************/
/*  Compare strings for equallity, handles NULL strings as ""                */
/*****************************************************************************/

extern Boolean strings_are_equal (a,b)
	String a,b;
{
	if (a==b)
		return True;
	if (a == NULL)
		return (*b == NULL);
	if (b == NULL)
		return (*a == NULL);

	while (*a==*b && *a){
		a++;
		b++;
	}
	/* if *a==*b then *a must be NULL */
	return (*a==*b);
}

/*****************************************************************************/
/*  Copies one string on to another and returns pointer to end of new string */
/*****************************************************************************/

extern String MonetStringCopyToEnd (dest, src)
	String dest, src;
{
	register char * d, *s;
	if (src)
		s = src;
	else
		s= "";
	for (d=dest;*s; ++s, ++d)
		*d = *s;
	*d = '\0';
	return d;
};

/*****************************************************************************/
/*  Concatinate an array of strings  */
/*****************************************************************************/

extern String MonetJoinStrings (argc, argv, between)
	int argc;
	char ** argv, * between;
{
	static char buf[2048]; /* !!! */
	String p;
	Cardinal i;
	if ( ! argv)
		return NULL;
	for (p = buf, *p = '\0', i = 0; i < (argc); ++i) {
		p = MonetStringCopyToEnd (p, argv[i]);
		if (between)
			p = MonetStringCopyToEnd (p, between);
	}
	return buf;
}

extern String MonetJoinStringsUntilNull (argv, between)
	char ** argv, * between;
{
	static char buf[2048]; /* !!! */
	String p;
	Cardinal i;
	if ( ! argv)
		return NULL;
	for (p = buf, *p = '\0', i = 0; argv[i]; ++i) {
		p = MonetStringCopyToEnd (p, argv[i]);
		if (between)
			p = MonetStringCopyToEnd (p, between);
	}
	return buf;
}


/*****************************************************************************/
/*  Debugging stuff  */
/*****************************************************************************/


extern char * malloc ();


extern void debug_on ()
{
	Config_debug = True;
}
extern void debug_off ()
{
	Config_debug = False;
}


/*****************************************************************************/
/*  Send message to output  */
/*****************************************************************************/

#ifdef VPRINTF
/*VARARGS2*/
extern void debug_message (va_alist)
	va_dcl
{
	va_list args;
	char *fmt;

	if (Config_debug == False ) return;

	(void) fprintf (stderr, "[Debug] ");

	va_start(args);
	fmt = va_arg(args, char *);
	(void) vfprintf (stderr, fmt, args);
	va_end(args);

	(void) fprintf (stderr, "\n");
	fflush (stderr);
}

/*VARARGS2*/
extern void sys_error (va_alist)
	va_dcl
{
	va_list args;
	char *fmt;

	(void) fprintf (stderr, "[System Error in %s] ", CurrentFunction);

	va_start(args);
	fmt = va_arg(args, char *);
	(void) vfprintf (stderr, fmt, args);
	va_end(args);

	(void) fprintf (stderr, "\n");
	fflush (stderr);
}

/*VARARGS2*/
extern void sys_warning (va_alist)
	va_dcl
{
	va_list args;
	char *fmt;

	(void) fprintf (stderr, "[System Warning in %s] ", CurrentFunction);

	va_start(args);
	fmt = va_arg(args, char *);
	(void) vfprintf (stderr, fmt, args);
	va_end(args);

	(void) fprintf (stderr, "\n");
	fflush (stderr);
}

#else /* VPRINTF */

/*VARARGS2*/
extern void debug_message (fmt, a,b,c,d,e,f,g,h,i)
	char * fmt;
{
	if (Config_debug == False ) return;
	(void) fprintf (stderr, "[Debug] ");
	(void) fprintf (stderr, fmt, a,b,c,d,e,f,g,h,i);
	(void) fprintf (stderr, "\n");
}

/*VARARGS2*/
extern void sys_error (fmt, a,b,c,d,e,f,g,h,i)
	char * fmt;
{
	(void) fprintf (stderr, "[System Error in %s] ", CurrentFunction);
	(void) fprintf (stderr, fmt, a,b,c,d,e,f,g,h,i);
	(void) fprintf (stderr, "\n");
	fflush (stderr);
}

/*VARARGS2*/
extern void sys_warning (fmt, a,b,c,d,e,f,g,h,i)
	char * fmt;
{
	(void) fprintf (stderr, "[System Warning in %s] ", CurrentFunction);
	(void) fprintf (stderr, fmt, a,b,c,d,e,f,g,h,i);
	(void) fprintf (stderr, "\n");
	fflush (stderr);
}

#endif /* VPRINTF */

/*****************************************************************************/
/*  Debuging  */
/*****************************************************************************/

extern void enter_procedure (func)
	char * func;
{
	return;
	CurrentFunction = func;
	debug_message ("Entering procedure [%s]\n", func);
}

/*****************************************************************************/
/*  Print File at Postscript Printer  */
/*****************************************************************************/

extern void print_postscript (filename)
	char * filename;
{
	int cc;
	char buffer[1024]; /* !!! */
	if ( !filename || *filename == NULL) {
		user_error ("No filename given for printer");
		return;
	}
	if (MonetStrlen (Config_postscript_printer_command) == 0) {
		user_error ("Sorry, no postscript printer command defined");
		return;
	}
	sprintf (buffer, "%s %s", Config_postscript_printer_command, filename);
	cc = system (buffer);
	if (cc == 0) {
		user_inform ("[%s] has been sent for printing", filename);
	} else {
		user_error ("[%s] has not been sent for printing", filename);
	}
}

/*****************************************************************************/
/* !!! Should be in the mapper directory                                     */
/* Returns NULL if cannot tidy string, ie wierd chars or newline             */
/* Space and tab are compressed and removed from the head and tail           */
/* This has a fairly obvious bug that strings greater than 512 will crash it */
/*****************************************************************************/

extern char * tidy_name (s)
char *s;
{
	char * current, * place;
	Boolean space = False;
#define SIZETIDYBUFFER 1024
	static char TidyBuffer[SIZETIDYBUFFER];

	if (!s)
		return "";

	current=s;
	for (place=TidyBuffer; *current!=NULL;current++) {
		if (isgraph (*current) && *current != '\"' && *current != '\'') {
			space = False;
			*place = *current;
			place ++;
		} else if (current==s) {
			/*  Ignore leading spaces  */
		} else if (!space) {
			*place = ' ';
			place ++;
			space = True;
		}
	}
	if (space)
		*(place-1) = NULL;
	else
		*place = NULL;
	return (TidyBuffer);
}

/*****************************************************************************/
/*  monet_strcat  */
/*****************************************************************************/

extern char * MonetStrcat (s1, s2)
	char * s1, *s2;
{
	char * new;
	new = MonetMalloc (MonetStrlen(s1)+MonetStrlen(s2)+2);
	(void) sprintf (new, "%s%s", s1,s2);
	return new;
}

/*****************************************************************************/
/*  Files  */
/*****************************************************************************/

extern FILE * MonetFopen (name, mode)
	char * name;
	char * mode;
{
	if (*name == '/' || *name == '~' || *name == '.') {
		return  fopen (name, mode);
	} else {
		return  fopen (name, mode);
	}
}


extern char * MonetFilename (name)
	char * name;
{
	static char filename [2048];
	if (*name == '/' || *name == '~' || *name == '.') {
		return  name;
	} else {
		(void) sprintf (filename, "%s/%s", Config_etc_directory, name);
		return filename;
	}
	/* NOTREACHED */
}

extern void give_a_beep ()
{
	user_inform (" !!!  Deafening Beeeeepppp ... ");
}

/*****************************************************************************/
/*  General Purpose  ,  Obsolete !!! */
/*****************************************************************************/

extern char * newstring (s)
	char * s;
{
	static char * message = "Unallocated";
	char * new;

	PROC("newstring");

	if ((new = malloc(MonetStrlen(s)+1)) == NULL) {
		sys_error ("Couldn't allocate space");
		return message;
	}
	return (strcpy (new, s));
}

extern char * my_malloc (len)
     int len;
{
  char * result;


  if ((result = malloc (len)) == NULL) {
    user_error ("my_malloc: cannot malloc %d bytes", len);
  }
  return (result);
}

extern char * copy_string (source)
     char  * source;
{
  char * target;

  target = my_malloc (MonetStrlen(source)+1);
  return (strcpy (target, source));
}

/*****************************************************************************/
/* Init and Finish */
/*****************************************************************************/


extern void Monet_init (program_name, finish, argc, argv)
	String program_name;
	MonetFinishRoutine finish;
	int argc;
	char **argv;
{
/*
	int             i;
	for (i = 1; i <= 18; i++)
		signal(i, NULL);
*/
	/*  Init debugging stuff */

	Config_finish_handler = finish;
	debug_off ();
	init_user_inform ();
	init_configure (program_name, argc, argv);
	init_helper ();
	init_logs ();
	if (Config_tcp_dns) {
		sethostent (True);
	}
	init_drawlib ();
	init_gather ();
	if (Config_monetd_delay <= 0) {
		user_error ("monetd_delay [%d] is too small", Config_monetd_delay);
		exit (1);
	}
}

extern void Monet_finish ()
{
	finish_gather ();
	finish_drawlib ();
	finish_logs ();
	finish_helper ();

	if (Config_tcp_dns) {
		endhostent ();
	}
/*
	int             i;

	for (i = 1; i <= 18; i++)
		signal(i, finish_system);
*/
	finish_configure ();
	finish_user_inform ();
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/lib/general/RCS/general.c,v 1.2 1991/07/10 12:50:54 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
