/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*  Defines some basic functions for monet script  */
/*****************************************************************************/

#include "script.h"
#include "general/Help.h"
#include "general/Channel.h"
#include "io/io.h"
#include <signal.h>
#include <sys/types.h>
#include <errno.h>
#include <sys/ioctl.h>

/***************************************************************************/

/***************************************************************************/

SCRIPTCALLBACK(do_version)
	version_message ();
ENDSC

SCRIPTCALLBACK(do_echo)
	int i;

	for (i = 0; arg[i]; ++i)
		write_report ("%s", arg[i]);
	writeln_report ("\n");
ENDSC

SCRIPTCALLBACK(do_debug)
	String name = arg[0];
	if (EQS (name, "off")) {
		writeln_report ("Setting debug off");
		debug_off ();
	} else {
		writeln_report ("Setting debug on");
		debug_on ();
	}
ENDSC

SCRIPTCALLBACK(do_false)
	result = NULL;
ENDSC

SCRIPTCALLBACK(do_true)
	result = "true";
ENDSC

SCRIPTCALLBACK(do_add)
	long value;
	if (arg[0] && arg[1]) {
		result = MonetMalloc (20);
		value = atoi(arg[0]) + atoi(arg[1]);
		(void) sprintf (result, "%ld", value);
	} else {
		result = "0";
	}
ENDSC

SCRIPTCALLBACK(do_mul)
	long value;
	if (arg[0] && arg[1]) {
		result = MonetMalloc (20);
		value = atoi(arg[0]) * atoi(arg[1]);
		(void) sprintf (result, "%ld", value);
	} else {
		result = "0";
	}
ENDSC

SCRIPTCALLBACK(do_sub)
	long value;
	if (arg[0] && arg[1]) {
		result = MonetMalloc (20);
		value = atoi(arg[0]) - atoi(arg[1]);
		(void) sprintf (result, "%ld", value);
	} else {
		result = "0";
	}
ENDSC

SCRIPTCALLBACK(do_div)
	long value;
	if (arg[0] && arg[1]) {
		result = MonetMalloc (20);
		value = atoi(arg[0]) / atoi(arg[1]);
		(void) sprintf (result, "%ld", value);
	} else {
		result = "0";
	}
ENDSC

SCRIPTCALLBACK(do_config)
	String name = arg[0];
	char variable [1024], value[1024]; /* !!! */
	int cc;

	if (!name) {
		cc = scanf (name, "%s %[^\n]", variable, value);
		if (cc != 2)
			user_error ("config <attribute> <value>");
		else
			configure_string (variable, value);
	} else {
		user_error ("config <attribute> <value>");
	}
ENDSC

SCRIPTCALLBACK(do_sh)
	/* !!! The output is not redirected */
	if (arg[0])
		system (arg[0]);
ENDSC

SCRIPTCALLBACK(do_left_string)

ENDSC

SCRIPTCALLBACK(do_input)
	if (arg) {
		FILE * f;
		String filename;

		filename = arg[0];
		if (f = fopen (filename, "r")) {
			Script_execute_fd (fileno (f), False);
			fclose (f);
		} else {
			user_error ("Could not open file [%s]", filename);
		}
	} else {
		user_error ("input <filename>");
	}
ENDSC

/*****************************************************************************/
/*  Init finish  */
/*****************************************************************************/

extern void Script_init_base ()
{
	ScriptMacro_deeper ();
	ScriptMacro_create ( "config",NULL,	do_config, 		"set configuration parameter" , "");
	ScriptMacro_create ( "echo",	NULL,	do_echo,	 	"echo to output" , "");
	ScriptMacro_create ( "copyr",	NULL,	copyright_message,	"copyright message", "");
	ScriptMacro_create ( "ver",	NULL,	do_version,	"which version of the software" , "");
	ScriptMacro_create ( "true",	NULL,	do_true, 		"always succeed" , "");
	ScriptMacro_create ( "false",	NULL,	do_false, 		"always fail" , "");
	ScriptMacro_create ( "fail",	NULL,	do_false, 		"always fail" , "");
	ScriptMacro_create ( "debug",	NULL,	do_debug,	 	"debug on|off" , "");
	ScriptMacro_create ( "sh",	NULL,	do_sh, 			"Unix (sh)ell command" , "");
	ScriptMacro_create ( "+",	NULL,	do_add,		 	"+ <a> <b>" , "");
	ScriptMacro_create ( "-",	NULL,	do_sub,		 	"- <a> <b>" , "");
	ScriptMacro_create ( "/",	NULL,	do_div,		 	"/ <a> <b>" , "");
	ScriptMacro_create ( "*",	NULL,	do_mul,		 	"* <a> <b>" , "");
  	ScriptMacro_create ( "input",	NULL,	do_input,	 	"commands from a file", "");
  	ScriptMacro_create ( "left",	NULL,	do_left_string,	 	"left <string> n", "");
}

extern void Script_finish_base ()
{
	ScriptMacro_shallower ();
}

/*****************************************************************************/
/*****************************************************************************/
/* $Header: //gaia/group.local/computer/monet/Xmonet/RCS/main.c,v 1.1 1991/03/26 12:00:14 a38 Exp a38 $ */
/*****************************************************************************/
/*****************************************************************************/
