#ifndef MONET_IO_H
#define MONET_IO_H

#include "general/NiceSocket.h"
#include "general/Channel.h"

#ifdef MONET_PROTOTYPES

typedef void (* BeforeSelectHandler) (int *, fd_set *readbits, fd_set *writebits, fd_set *other, struct timeval *timer);
typedef void (* AfterSelectHandler) (int, fd_set readbits, fd_set writebits, fd_set other);

extern void wait_for_messages (long period, long timenow, BeforeSelectHandler before, AfterSelectHandler after);

#else

typedef void (* BeforeSelectHandler) ();
typedef void (* AfterSelectHandler) ();

extern void wait_for_messages ();

#endif


#endif
