/******************************************************************************/
/******************************************************************************/
/*  $Header$  */
/******************************************************************************/
/* $Log$ */
/******************************************************************************/

#include "map/Drawing.h"

/***********************************************************************/
/*  We want the user to be able to define actions to be taken when an  */
/*  object is clicked */
/***********************************************************************/

/***********************************************************************/
/* List general information about a system */
/***********************************************************************/

static Boolean list_generalInformation (drawing)
	Drawing drawing;
{
	Entity class, sys;
	String title;
	Cardinal subcomponents;
	char buffer[1024]; /* !!! */

	if (drawing == NULL) {
		sys_error ("NULL drawing");
		return False;
	}
	sys = ENTITY(drawing);
	subcomponents = sizeOf_entityList (Entity_subcomponents (sys));
	title = Entity_title (sys);
	class = Entity_classOf(sys);

	start_report ("Reporting ...");
	if (Entity_isClass(sys)) {
		user_inform ("Sorry no information about classes");
	} else if (Drawing_isMap (drawing)) {
		writeln_report ("Map [%s] has %d picture elements", title, subcomponents);
	} else if (class == Std_Type.button) {
		writeln_report ("Button [%s] refers to %d components", title, subcomponents);
#ifdef ABCDEFG
	} else if (class == Std_Type.ip_network) {
		int a,b,c,d, cc; 
		writeln_report ("Sorry, only does class C networks so far !!!");
		cc = sscanf (TITLE(sys), "%d.%d.%d.%d", &a,&b,&c,&d);
		if (cc != 4) {
			user_error ("Ip network name not valid [%s]", TITLE(sys));
		} else {
			writeln_report ("Listing nameserver database entry for [%s]", title);
			(void) sprintf (buffer, "host -t any %d.%d.%d.in-addr.arpa", c,b,a);
			ShellCommand_report (buffer);
		}
		/*    writeln_report ("Listing whois database entry for [%s]", title);
		    (void) sprintf (buffer, "whois %s ", TITLE(sys));
			ShellCommand_report (buffer);
		*/
	} else if (class == Std_Type.ip_host) {
		writeln_report ("Listing nameserver database entry for [%s]", title);
		(void) sprintf (buffer, "host -t any %s", TITLE(sys));
		ShellCommand_report (buffer);
#endif
	} else if (class == Std_Type.x25_host) {
		writeln_report ("Listing addresses of [%s]  !!! Not implemented", title);
	} else if (isInterface (sys)) {
		writeln_report ("Don't know anything about interface [%s]", title);
	} else if (isSystem (sys)) {
		writeln_report ("Don't know anything about system [%s]", title);
	} else {
		sys_error ("Don't know type of [%s]", title);
	}
	end_report ();
	return True;
}

extern void Drawing_do_action (drawing)
	Drawing drawing;
{
	String action;
/*	if (Drawing_isMap (drawing)) {
		toggle_expandMap (drawing->map_stuff);
	} else
*/
	if (Entity_isClass (ENTITY(drawing))) {
		Entity s;
		user_inform ("Selecting Instances of [%s]", Drawing_title (drawing));
		FOR_ENTITYLIST (s, Entity_get_instances (ENTITY(drawing)))
			Entity_select_drawings (s);
	} else if (Drawing_isButton (drawing)) {
		Entity s;
                FOR_ENTITYLIST (s, Entity_subcomponents (ENTITY(drawing)))
			Entity_select_drawings (s);
	} else if (action = Entity_get_action (ENTITY(drawing))) {
		Script_execute (action);
	} else {
		list_generalInformation (drawing);
	}
}

/******************************************************************************/
/******************************************************************************/
/*  $Header$  */
/******************************************************************************/
/******************************************************************************/
