#ifndef MONET_QUERY_LIB_H
#define MONET_QUERY_LIB_H

#include "general/Channel.h"
#include "general/Log.h"

/***************************************************************************/
/*  Request priority, defines how important querying of an object is       */
/***************************************************************************/

typedef int Priority;
#define VERY_HIGH_PRIORITY     2
#define HIGH_PRIORITY          1
#define DEFAULT_PRIORITY       0
#define LOW_PRIORITY          -1
#define VERY_LOW_PRIORITY     -2

/***************************************************************************/
/*  Function Prototypes  */
/***************************************************************************/

#ifdef MONET_PROTOTYPES

extern void	Query_init		(void);
extern void	Query_finish		(void);
extern Cardinal	Query_all		(Log log);
extern void	Query_log_all		(Log);
extern String	Query2String		(Query);
extern Query	Query_create		(String query_class, Entity, String text);
extern void	Query_free		(Query);
extern void	Query_set_frequency	(query, frequency);
extern QueryClass String2QueryClass	(String);

#else

extern void	Query_init		();
extern void	Query_finish		();
extern Cardinal	Query_all		();
extern void	Query_log_all		();
extern String	Query2String		();
extern Query	Query_create		();
extern void	Query_free		();
extern void	Query_set_frequency	();
extern QueryClass String2QueryClass	();

#endif


#endif /* _QUERY/LIB_H_ */

