/***************************************************************************/
/***************************************************************************/
/*  $Header$  */
/***************************************************************************/
/***************************************************************************/
/*  The SNMP stuff is taken from 'snmptapd' an application that comes with */
/*  the cmu snmp stuff.  */
/*  !!! It is not tested although the makefiles have been */
/*  !!! altered for it.  I would like to first of all just get it to act like */
/*  !!! snmptrad, then use these traps usefully to report back to the mapper */
/***************************************************************************/

#include "query_class.h"
#include "general/NiceSocket.h"
#include "query/SnmpLib.h"
#include <errno.h>
#include <sys/file.h>

#ifdef CMU_SNMP

struct snmp_session session, *ss;

static int Print = 0;
Boolean SnmpTraps = False;
int snmp_dump_packet = 0;

static char * trap_description(trap)
    int trap;
{
	switch(trap) {
	case SNMP_TRAP_COLDSTART:
	    return "Cold Start";
	case SNMP_TRAP_WARMSTART:
	    return "Warm Start";
	case SNMP_TRAP_LINKDOWN:
	    return "Link Down";
	case SNMP_TRAP_LINKUP:
	    return "Link Up";
	case SNMP_TRAP_AUTHFAIL:
	    return "Authentication Failure";
	case SNMP_TRAP_EGPNEIGHBORLOSS:
	    return "EGP Neighbor Loss";
	case SNMP_TRAP_ENTERPRISESPECIFIC:
	    return "Enterprise Specific";
	default:
	    return "Unknown Type";
	}
}

static int snmp_input(op, session, reqid, pdu, magic)
    int op;
    struct snmp_session *session;
    int reqid;
    struct snmp_pdu *pdu;
    void *magic;
{
    char buf[64];

    if (op == RECEIVED_MESSAGE && pdu->command == TRP_REQ_MSG){
	if (Print){
	    user_inform("%s: %s Trap (%d) Uptime: %s", inet_ntoa(pdu->agent_addr.sin_addr),
		trap_description(pdu->trap_type), pdu->specific_type, uptime_string(pdu->time, buf));
	} else {
	    user_error("%s: %s Trap (%d) Uptime: %s", inet_ntoa(pdu->agent_addr.sin_addr),
		trap_description(pdu->trap_type), pdu->specific_type, uptime_string(pdu->time, buf));
	}
    } else if (op == TIMED_OUT){
	sys_error("Timeout: This shouldn't happen!\n");
    }
}

#endif /* CMU_SNMP */



extern void init_snmp_trap ()
{
#ifdef CMU_SNMP
	bzero((char *)&session, sizeof(struct snmp_session));
	session.peername = NULL;
	session.community = NULL;
	session.community_len = 0;
	session.retries = SNMP_DEFAULT_RETRIES;
	session.timeout = SNMP_DEFAULT_TIMEOUT;
	session.authenticator = NULL;
	session.callback = snmp_input;
	session.callback_magic = NULL;
	session.local_port = SNMP_TRAP_PORT;
	ss = snmp_open(&session);
	if (ss == NULL) {
		user_error("Couldn't open snmp for traps (port %d)", SNMP_TRAP_PORT);
		SnmpTraps = False;
	} else {
		SnmpTraps = True;
	}
#endif /* CMU_SNMP */

}

/***************************************************************************/
/***************************************************************************/
/*  $Header$ */
/***************************************************************************/
/***************************************************************************/
