/*****************************************************************************/
/*****************************************************************************/
/* $Header$ */
/*****************************************************************************/
/*****************************************************************************/

#include "general/General.h"
#include "xmonet/Widget.h"
#include "general/Help.h"

/******************************************************************************/
/*  Confirm Box  */
/******************************************************************************/

static Boolean Confirmation;
static char    ConfirmMessage[1024]; /*!!!*/
static ConfirmRoutine ConfirmProc = NULL;
static Widget  ConfirmLabelWidget;
static Widget ConfirmBox           = (Widget) 0;

static void xio_confirm_box (proc, message)
	ConfirmRoutine proc;
	char * message;
{
	if (!ConfirmBox) {
		fprintf(stderr, "Null confirm_box widget\n");
		ConfirmBox = WcFullNameToWidget (toplevel, "*confirm");
		if (ConfirmBox) {
			fprintf(stderr, "Found confirm_box widget\n");
		}
	}
	if (ConfirmBox) {
		Arg args [1];
		(void) strcpy (ConfirmMessage, message);
		ConfirmProc = proc;

		if (ConfirmLabelWidget) {
			XtSetArg(args[0], XtNlabel, ConfirmMessage);
			XtSetValues(ConfirmLabelWidget, args, ONE);
		}
		popup_central (toplevel, ConfirmBox, XtGrabExclusive);
	}
} 

CALLBACK(DoConfirmActionCB)
	ConfirmProc ();
ENDCB

CALLBACK(RegisterConfirmPopupCB)
	String w_name = (String) client_data;
	Widget popup;

	if ( ! (popup = WidgetName2Popup (widget, w_name)))
		return;
	(void) set_confirm_box_routine (xio_confirm_box);
	ConfirmBox = popup;
ENDCB

CALLBACK(RegisterConfirmMessageCB)
	Widget popup;
	String w_name = (String) client_data;
	char clean_name[1024]; /* !!! */

	(void) set_confirm_box_routine (xio_confirm_box);
	(void) WcCleanName (w_name, clean_name);
	popup = WcFullNameToWidget (widget, clean_name);
	if ( ! popup) {
		user_error ("No such popup widget [%s]", w_name);
		return;
	}
	ConfirmLabelWidget = popup;
ENDCB

/*****************************************************************************/
/*****************************************************************************/
/* $Header$ */
/*****************************************************************************/
/*****************************************************************************/
